searchNodes=[{"doc":"","ref":"ssh_signature.html","title":"ssh_signature","type":"module"},{"doc":"Equivalent to sign(Data, Key, NS, \#{}) .","ref":"ssh_signature.html#sign/3","title":"ssh_signature.sign/3","type":"function"},{"doc":"Sign Data using SSH signature format with Key . The NS must be not empty. Options hash - hash algorithm used on input data. Can be either sha256 or sha512 . Defaults to sha512 .","ref":"ssh_signature.html#sign/4","title":"ssh_signature.sign/4","type":"function"},{"doc":"Verify Signature of Data . Notice that this function do not check authenticity of the provided key. That is left to the user to check whether key used for signing match the requirements.","ref":"ssh_signature.html#verify/2","title":"ssh_signature.verify/2","type":"function"},{"doc":"","ref":"ssh_signature.html#t:hash_algorithm/0","title":"ssh_signature.hash_algorithm/0","type":"type"},{"doc":"","ref":"ssh_signature.html#t:namespace/0","title":"ssh_signature.namespace/0","type":"type"},{"doc":"Implementation of SSH signatures in Erlang. It uses only stuff distributed with OTP, so no external dependencies needed. Currently supported algorithms: RSA Ed25519 Ed448 - not tested, as my implementation of OpenSSH do not support Ed448 keys","ref":"readme.html","title":"SSH signatures for Erlang","type":"extras"},{"doc":"There are just 3 exported functions: sign/{3,4} which allows signing data verify/2 that verifies the signature for given data and outputs details about signature % First we need the private key that we will use for signing. % For the purpose of this example just use RSA-4096 SecretKey = public_key : generate_key ( { rsa , 4096 , 3 } ) , Data = &lt;&lt; &quot;Foo&quot; &gt;&gt; , % Sign data using our key. 3rd argument there is a namespace, that must be % non-empty string. Signature = ssh_signature : sign ( Data , SecretKey , &quot;text&quot; ) , % The created signature is already in armoured (ASCII-only) format. % Now we can check if the signature is correct { ok , \#{ public_key := PubKey , ns := &lt;&lt; &quot;test&quot; &gt;&gt; , signature := Sig } } = ssh_signature : verify ( Data , Signature ) . % Notice that we do not pass public key to verify/2, it is left to the user to % check whether the returned public key is trusted.","ref":"readme.html#usage","title":"SSH signatures for Erlang - Usage","type":"extras"},{"doc":"See LICENSE","ref":"readme.html#license","title":"SSH signatures for Erlang - License","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS Copyright 2022, Łukasz Niemier &lt;lukasz@niemier.pl&gt;. Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"","ref":"changelog.html","title":"CHANGELOG","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"CHANGELOG - Unreleased","type":"extras"},{"doc":"Bug Fixes conditionaly use removed function ( 8461cfb ) install OpenSSL GitHub Actions ( 09dd972 ) Documentation add protocol description to the docs ( efd03d2 ) add example in README ( b694f60 )","ref":"changelog.html#v0-1-0-2022-08-11","title":"CHANGELOG - v0.1.0 - 2022-08-11","type":"extras"},{"doc":"This document describes a lightweight SSH Signature format that is compatible with SSH keys and wire formats. At present, only detached and armored signatures are supported. 1. Armored format The Armored SSH signatures consist of a header, a base64 encoded blob, and a footer. The header is the string &quot;-----BEGIN SSH SIGNATURE-----&quot; followed by a newline. The footer is the string &quot;-----END SSH SIGNATURE-----&quot; immediately after a newline. The header MUST be present at the start of every signature. Files containing the signature MUST start with the header. Likewise, the footer MUST be present at the end of every signature. The base64 encoded blob SHOULD be broken up by newlines every 76 characters. Example: -----BEGIN SSH SIGNATURE----- U1NIU0lHAAAAAQAAADMAAAALc3NoLWVkMjU1MTkAAAAgJKxoLBJBivUPNTUJUSslQTt2hD jozKvHarKeN8uYFqgAAAADZm9vAAAAAAAAAFMAAAALc3NoLWVkMjU1MTkAAABAKNC4IEbt Tq0Fb56xhtuE1/lK9H9RZJfON4o6hE9R4ZGFX98gy0+fFJ/1d2/RxnZky0Y7GojwrZkrHT FgCqVWAQ== -----END SSH SIGNATURE----- 2. Blob format #define MAGIC_PREAMBLE &quot;SSHSIG&quot; #define SIG_VERSION 0x01 byte[6] MAGIC_PREAMBLE uint32 SIG_VERSION string publickey string namespace string reserved string hash_algorithm string signature The publickey field MUST contain the serialisation of the public key used to make the signature using the usual SSH encoding rules, i.e RFC4253, RFC5656, draft-ietf-curdle-ssh-ed25519-ed448, etc. Verifiers MUST reject signatures with versions greater than those they support. The purpose of the namespace value is to specify a unambiguous interpretation domain for the signature, e.g. file signing. This prevents cross-protocol attacks caused by signatures intended for one intended domain being accepted in another. The namespace value MUST NOT be the empty string. The reserved value is present to encode future information (e.g. tags) into the signature. Implementations should ignore the reserved field if it is not empty. Data to be signed is first hashed with the specified hash_algorithm. This is done to limit the amount of data presented to the signature operation, which may be of concern if the signing key is held in limited or slow hardware or on a remote ssh-agent. The supported hash algorithms are &quot;sha256&quot; and &quot;sha512&quot;. The signature itself is made using the SSH signature algorithm and encoding rules for the chosen key type. For RSA signatures, the signature algorithm must be &quot;rsa-sha2-512&quot; or &quot;rsa-sha2-256&quot; (i.e. not the legacy RSA-SHA1 &quot;ssh-rsa&quot;). This blob is encoded as a string using the RFC4253 encoding rules and base64 encoded to form the middle part of the armored signature. 3. Signed Data, of which the signature goes into the blob above #define MAGIC_PREAMBLE &quot;SSHSIG&quot; byte[6] MAGIC_PREAMBLE string namespace string reserved string hash_algorithm string H(message) The preamble is the six-byte sequence &quot;SSHSIG&quot;. It is included to ensure that manual signatures can never be confused with any message signed during SSH user or host authentication. The reserved value is present to encode future information (e.g. tags) into the signature. Implementations should ignore the reserved field if it is not empty. The data is concatenated and passed to the SSH signing function. $OpenBSD: PROTOCOL.sshsig,v 1.4 2020/08/31 00:17:41 djm Exp $","ref":"protocol-sshsig.html","title":"PROTOCOL.sshsig","type":"extras"}]